using System;
using System.Collections.Generic;
using System.Text;

namespace Services.WCF.Hosting
{
    [AttributeUsage(AttributeTargets.Class)] 
    public class HostServiceAttribute:Attribute 
    {
        String _name;
        String _display;
        String _description;
        
        public HostServiceAttribute(String Name)
        {
            _name = Name;
            _display = Name;
            _description = String.Empty;
        }

        public HostServiceAttribute(String Name, String Description)
        {
            _name = Name;
            _display = Name;
            _description = Description;
        }

        public HostServiceAttribute(String Name, String Description, String DisplayName)
        {
            _name = Name;
            _display = DisplayName;
            _description = Description;
        }

        public String Name
        {
            get {return _name;}
            set { _name = value;}
        }

        public String Description
        {
            get { return _description; }
            set { _description = value; }
        }

        public String DisplayName
        {
            get { return _display; }
            set { _display = value; }
        }
    }
}
